[arch-commits] Commit in ghc/repos (8 files)

Evangelos Foutras foutrelis at archlinux.org
Tue Oct 6 23:21:38 UTC 2015


    Date: Wednesday, October 7, 2015 @ 01:21:38
  Author: foutrelis
Revision: 248436

archrelease: copy trunk to staging-i686, staging-x86_64

Added:
  ghc/repos/staging-i686/
  ghc/repos/staging-i686/PKGBUILD
    (from rev 248435, ghc/trunk/PKGBUILD)
  ghc/repos/staging-i686/ghc.install
    (from rev 248435, ghc/trunk/ghc.install)
  ghc/repos/staging-i686/print-provides-replaces.sh
    (from rev 248435, ghc/trunk/print-provides-replaces.sh)
  ghc/repos/staging-x86_64/
  ghc/repos/staging-x86_64/PKGBUILD
    (from rev 248435, ghc/trunk/PKGBUILD)
  ghc/repos/staging-x86_64/ghc.install
    (from rev 248435, ghc/trunk/ghc.install)
  ghc/repos/staging-x86_64/print-provides-replaces.sh
    (from rev 248435, ghc/trunk/print-provides-replaces.sh)

-------------------------------------------+
 staging-i686/PKGBUILD                     |  107 ++++++++++++++++++++++++++++
 staging-i686/ghc.install                  |   10 ++
 staging-i686/print-provides-replaces.sh   |   47 ++++++++++++
 staging-x86_64/PKGBUILD                   |  107 ++++++++++++++++++++++++++++
 staging-x86_64/ghc.install                |   10 ++
 staging-x86_64/print-provides-replaces.sh |   47 ++++++++++++
 6 files changed, 328 insertions(+)

Copied: ghc/repos/staging-i686/PKGBUILD (from rev 248435, ghc/trunk/PKGBUILD)
===================================================================
--- staging-i686/PKGBUILD	                        (rev 0)
+++ staging-i686/PKGBUILD	2015-10-06 23:21:38 UTC (rev 248436)
@@ -0,0 +1,107 @@
+# $Id$
+# Maintainer: Vesa Kaihlavirta <vesa at archlinux.org>
+# Contributor: Thomas Dziedzic <gostrc at gmail.com>
+
+# Special note for devs looking to upgrade this package:
+#   ghc places a unique hash for each library when it is built.
+#   Libraries depend on versions specified by those hashes.
+#   This implies that all libraries need to be rebuilt when ghc is rebuilt.
+
+# use the following command to print out packages that need to get rebuilt
+# grep -r ghc /var/abs/ | awk -F '/' '{ print $5; }' | sort -u
+
+pkgname=ghc
+pkgver=7.10.2
+pkgrel=1
+pkgdesc='The Glasgow Haskell Compiler'
+arch=('i686' 'x86_64')
+url='http://www.haskell.org/ghc/'
+license=('custom')
+depends=('perl' 'gmp' 'gcc' 'libffi')
+makedepends=('ghc' 'perl' 'libxslt' 'docbook-xsl')
+provides=('haskell-array=0.5.1.0'
+          'haskell-base=4.8.1.0'
+          'haskell-binary=0.7.5.0'
+          'haskell-bin-package-db=0.0.0.0'
+          'haskell-bytestring=0.10.6.0'
+          'haskell-containers=0.5.6.2'
+          'haskell-deepseq=1.4.1.1'
+          'haskell-directory=1.2.2.0'
+          'haskell-filepath=1.4.0.0'
+          'haskell-ghc-prim=0.4.0.0'
+          'haskell-haskeline=0.7.2.1'
+          'haskell-hoopl=3.10.0.2'
+          'haskell-hpc=0.6.0.2'
+          'haskell-integer-gmp=1.0.0.0'
+          'haskell-pretty=1.1.2.0'
+          'haskell-process=1.2.3.0'
+          'haskell-template-haskell=2.10.0.0'
+          'haskell-terminfo=0.4.0.1'
+          'haskell-time=1.5.0.1'
+          'haskell-transformers=0.4.2.0'
+          'haskell-unix=2.7.1.0'
+          'haskell-xhtml=3000.2.1'
+          'haskell-cabal=1.22.4.0')
+replaces=('haskell-array'
+          'haskell-base'
+          'haskell-binary'
+          'haskell-bin-package-db'
+          'haskell-bytestring'
+          'haskell-containers'
+          'haskell-deepseq'
+          'haskell-directory'
+          'haskell-filepath'
+          'haskell-ghc-prim'
+          'haskell-haskeline'
+          'haskell-hoopl'
+          'haskell-hpc'
+          'haskell-integer-gmp'
+          'haskell-pretty'
+          'haskell-process'
+          'haskell-template-haskell'
+          'haskell-terminfo'
+          'haskell-time'
+          'haskell-transformers'
+          'haskell-unix'
+          'haskell-xhtml'
+          'haskell-cabal')
+install='ghc.install'
+options=('staticlibs')
+source=("https://downloads.haskell.org/~ghc/$pkgver/$pkgname-$pkgver-src.tar.xz")
+noextract=("$pkgname-$pkgver-src.tar.xz")
+md5sums=('fc1269fbc52513fa6b2ae6051c365bc3')
+
+prepare() {
+  # Need to extract this tarball with a UTF-8 locale instead of a chroot's "C"
+  # locale; otherwise we get:
+  #   bsdtar: Pathname can't be converted from UTF-8 to current locale.
+  LANG=en_US.UTF-8 bsdtar xf $pkgname-$pkgver-src.tar.xz
+
+  cd ghc-$pkgver
+
+  # We select the following build profile:
+  #   Full build with max optimisation and everything enabled (very slow build)
+  cp mk/build.mk{.sample,}
+  sed -i '1iBuildFlavour = perf' mk/build.mk
+}
+
+build() {
+  cd ghc-$pkgver
+
+  ./configure \
+    --prefix=/usr \
+    --with-system-libffi \
+    --with-ffi-includes=$(pkg-config --variable=includedir libffi)
+  make
+}
+
+package() {
+  cd ghc-$pkgver
+
+  make DESTDIR="$pkgdir" install
+
+  install -Dm644 utils/completion/ghc.bash \
+    "$pkgdir/usr/share/bash-completion/completions/ghc"
+
+  install -Dm644 LICENSE "$pkgdir/usr/share/licenses/$pkgname/LICENSE"
+}

Copied: ghc/repos/staging-i686/ghc.install (from rev 248435, ghc/trunk/ghc.install)
===================================================================
--- staging-i686/ghc.install	                        (rev 0)
+++ staging-i686/ghc.install	2015-10-06 23:21:38 UTC (rev 248436)
@@ -0,0 +1,10 @@
+pre_upgrade() {
+  echo '==> Unregistering cabalized packages...'
+  [[ -d /usr/share/haskell ]] && find /usr/share/haskell -maxdepth 2 -name 'unregister.sh' -exec {} \;
+  echo '==> Done.'
+}
+
+post_upgrade() {
+  echo '==> All cabalized packages need to be reinstalled now.'
+  echo '==> See /usr/share/haskell/ for a tentative list of affected packages.'
+}

Copied: ghc/repos/staging-i686/print-provides-replaces.sh (from rev 248435, ghc/trunk/print-provides-replaces.sh)
===================================================================
--- staging-i686/print-provides-replaces.sh	                        (rev 0)
+++ staging-i686/print-provides-replaces.sh	2015-10-06 23:21:38 UTC (rev 248436)
@@ -0,0 +1,47 @@
+#!/bin/bash
+
+. PKGBUILD
+
+if [[ ! -d src/ghc-${pkgver}/libraries ]]; then
+  echo "error: no directory src/ghc-${pkgver}/libraries: You must extract the source tarball under src/"
+  exit 1
+fi
+
+declare -A exclude
+# no Win32 cause we're not building on windows
+exclude['Win32']=1
+# no integer-simple because we use integer-gmp
+exclude['integer-simple']=1
+# integer-gmp was replaced with integer-gmp2
+exclude['integer-gmp']=1
+# extract excluded libraries from ghc.mk
+for exclude_pkg in $(sed 's/PKGS_THAT_ARE_INTREE_ONLY := //p' -n src/ghc-${pkgver}/ghc.mk); do
+  exclude[${exclude_pkg}]=1
+done
+
+cd src/ghc-${pkgver}/libraries
+
+# $1 is the name of the variable
+# $2 is the string for the test, either '=' or '<'
+print_var() {
+  printf "$1=("
+  for path in $(ls ./*/*.cabal); do
+    dirname=$(echo $path | awk -F '/' '{ print $2 }')
+    cabalfile=$(echo $path | awk -F '/' '{ print $3 }')
+    cabalname=$(basename $cabalfile .cabal)
+    [[ ${exclude[${dirname}]} ]] && continue
+    version=$(awk 'tolower($0) ~ /^version:/ {print $2 }' $path)
+    printf "'haskell-$cabalname"
+    [[ -n "$2" ]] && printf "$2$version"
+    printf "'\n          "
+  done
+  # also add cabal
+  version=$(awk 'tolower($0) ~ /^version:/ { print $2 }' Cabal/Cabal/Cabal.cabal)
+  printf "'haskell-cabal"
+  [[ -n "$2" ]] && printf "$2$version"
+  printf "'\n          "
+  echo -e '\b)'
+}
+
+print_var 'provides' '='
+print_var 'replaces'

Copied: ghc/repos/staging-x86_64/PKGBUILD (from rev 248435, ghc/trunk/PKGBUILD)
===================================================================
--- staging-x86_64/PKGBUILD	                        (rev 0)
+++ staging-x86_64/PKGBUILD	2015-10-06 23:21:38 UTC (rev 248436)
@@ -0,0 +1,107 @@
+# $Id$
+# Maintainer: Vesa Kaihlavirta <vesa at archlinux.org>
+# Contributor: Thomas Dziedzic <gostrc at gmail.com>
+
+# Special note for devs looking to upgrade this package:
+#   ghc places a unique hash for each library when it is built.
+#   Libraries depend on versions specified by those hashes.
+#   This implies that all libraries need to be rebuilt when ghc is rebuilt.
+
+# use the following command to print out packages that need to get rebuilt
+# grep -r ghc /var/abs/ | awk -F '/' '{ print $5; }' | sort -u
+
+pkgname=ghc
+pkgver=7.10.2
+pkgrel=1
+pkgdesc='The Glasgow Haskell Compiler'
+arch=('i686' 'x86_64')
+url='http://www.haskell.org/ghc/'
+license=('custom')
+depends=('perl' 'gmp' 'gcc' 'libffi')
+makedepends=('ghc' 'perl' 'libxslt' 'docbook-xsl')
+provides=('haskell-array=0.5.1.0'
+          'haskell-base=4.8.1.0'
+          'haskell-binary=0.7.5.0'
+          'haskell-bin-package-db=0.0.0.0'
+          'haskell-bytestring=0.10.6.0'
+          'haskell-containers=0.5.6.2'
+          'haskell-deepseq=1.4.1.1'
+          'haskell-directory=1.2.2.0'
+          'haskell-filepath=1.4.0.0'
+          'haskell-ghc-prim=0.4.0.0'
+          'haskell-haskeline=0.7.2.1'
+          'haskell-hoopl=3.10.0.2'
+          'haskell-hpc=0.6.0.2'
+          'haskell-integer-gmp=1.0.0.0'
+          'haskell-pretty=1.1.2.0'
+          'haskell-process=1.2.3.0'
+          'haskell-template-haskell=2.10.0.0'
+          'haskell-terminfo=0.4.0.1'
+          'haskell-time=1.5.0.1'
+          'haskell-transformers=0.4.2.0'
+          'haskell-unix=2.7.1.0'
+          'haskell-xhtml=3000.2.1'
+          'haskell-cabal=1.22.4.0')
+replaces=('haskell-array'
+          'haskell-base'
+          'haskell-binary'
+          'haskell-bin-package-db'
+          'haskell-bytestring'
+          'haskell-containers'
+          'haskell-deepseq'
+          'haskell-directory'
+          'haskell-filepath'
+          'haskell-ghc-prim'
+          'haskell-haskeline'
+          'haskell-hoopl'
+          'haskell-hpc'
+          'haskell-integer-gmp'
+          'haskell-pretty'
+          'haskell-process'
+          'haskell-template-haskell'
+          'haskell-terminfo'
+          'haskell-time'
+          'haskell-transformers'
+          'haskell-unix'
+          'haskell-xhtml'
+          'haskell-cabal')
+install='ghc.install'
+options=('staticlibs')
+source=("https://downloads.haskell.org/~ghc/$pkgver/$pkgname-$pkgver-src.tar.xz")
+noextract=("$pkgname-$pkgver-src.tar.xz")
+md5sums=('fc1269fbc52513fa6b2ae6051c365bc3')
+
+prepare() {
+  # Need to extract this tarball with a UTF-8 locale instead of a chroot's "C"
+  # locale; otherwise we get:
+  #   bsdtar: Pathname can't be converted from UTF-8 to current locale.
+  LANG=en_US.UTF-8 bsdtar xf $pkgname-$pkgver-src.tar.xz
+
+  cd ghc-$pkgver
+
+  # We select the following build profile:
+  #   Full build with max optimisation and everything enabled (very slow build)
+  cp mk/build.mk{.sample,}
+  sed -i '1iBuildFlavour = perf' mk/build.mk
+}
+
+build() {
+  cd ghc-$pkgver
+
+  ./configure \
+    --prefix=/usr \
+    --with-system-libffi \
+    --with-ffi-includes=$(pkg-config --variable=includedir libffi)
+  make
+}
+
+package() {
+  cd ghc-$pkgver
+
+  make DESTDIR="$pkgdir" install
+
+  install -Dm644 utils/completion/ghc.bash \
+    "$pkgdir/usr/share/bash-completion/completions/ghc"
+
+  install -Dm644 LICENSE "$pkgdir/usr/share/licenses/$pkgname/LICENSE"
+}

Copied: ghc/repos/staging-x86_64/ghc.install (from rev 248435, ghc/trunk/ghc.install)
===================================================================
--- staging-x86_64/ghc.install	                        (rev 0)
+++ staging-x86_64/ghc.install	2015-10-06 23:21:38 UTC (rev 248436)
@@ -0,0 +1,10 @@
+pre_upgrade() {
+  echo '==> Unregistering cabalized packages...'
+  [[ -d /usr/share/haskell ]] && find /usr/share/haskell -maxdepth 2 -name 'unregister.sh' -exec {} \;
+  echo '==> Done.'
+}
+
+post_upgrade() {
+  echo '==> All cabalized packages need to be reinstalled now.'
+  echo '==> See /usr/share/haskell/ for a tentative list of affected packages.'
+}

Copied: ghc/repos/staging-x86_64/print-provides-replaces.sh (from rev 248435, ghc/trunk/print-provides-replaces.sh)
===================================================================
--- staging-x86_64/print-provides-replaces.sh	                        (rev 0)
+++ staging-x86_64/print-provides-replaces.sh	2015-10-06 23:21:38 UTC (rev 248436)
@@ -0,0 +1,47 @@
+#!/bin/bash
+
+. PKGBUILD
+
+if [[ ! -d src/ghc-${pkgver}/libraries ]]; then
+  echo "error: no directory src/ghc-${pkgver}/libraries: You must extract the source tarball under src/"
+  exit 1
+fi
+
+declare -A exclude
+# no Win32 cause we're not building on windows
+exclude['Win32']=1
+# no integer-simple because we use integer-gmp
+exclude['integer-simple']=1
+# integer-gmp was replaced with integer-gmp2
+exclude['integer-gmp']=1
+# extract excluded libraries from ghc.mk
+for exclude_pkg in $(sed 's/PKGS_THAT_ARE_INTREE_ONLY := //p' -n src/ghc-${pkgver}/ghc.mk); do
+  exclude[${exclude_pkg}]=1
+done
+
+cd src/ghc-${pkgver}/libraries
+
+# $1 is the name of the variable
+# $2 is the string for the test, either '=' or '<'
+print_var() {
+  printf "$1=("
+  for path in $(ls ./*/*.cabal); do
+    dirname=$(echo $path | awk -F '/' '{ print $2 }')
+    cabalfile=$(echo $path | awk -F '/' '{ print $3 }')
+    cabalname=$(basename $cabalfile .cabal)
+    [[ ${exclude[${dirname}]} ]] && continue
+    version=$(awk 'tolower($0) ~ /^version:/ {print $2 }' $path)
+    printf "'haskell-$cabalname"
+    [[ -n "$2" ]] && printf "$2$version"
+    printf "'\n          "
+  done
+  # also add cabal
+  version=$(awk 'tolower($0) ~ /^version:/ { print $2 }' Cabal/Cabal/Cabal.cabal)
+  printf "'haskell-cabal"
+  [[ -n "$2" ]] && printf "$2$version"
+  printf "'\n          "
+  echo -e '\b)'
+}
+
+print_var 'provides' '='
+print_var 'replaces'



More information about the arch-commits mailing list